> For the complete documentation index, see [llms.txt](https://docs.fantom.foundation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fantom.foundation/build-on-opera/tutorials/create-variable-cap-asset.md).

# Create Variable-Cap Asset

Variable-cap assets are fungible tokens for which additional quantities can be minted after creation.&#x20;

## Create the Asset

1. Write the token smart contract:
   1. <https://github.com/OpenZeppelin/openzeppelin-contracts/blob/master/contracts/token/ERC20/ERC20.sol>
   2. Functions
      1. name()
      2. symbol()
      3. decimals()
      4. totalSupply()
      5. balanceOf(account)
      6. transfer(recipient, amount)
      7. allowance(owner, spender)
      8. approve(spender, amount)
      9. transferFrom(sender, recipient, amount)
      10. increaseAllowance(spender, addedValue)
      11. decreaseAllowance(spender, subtractedValue)
      12. \_transfer(sender, recipient, amount)
      13. \_mint(account, amount)
      14. \_burn(account, amount)
      15. \_approve(owner, spender, amount)
      16. \_setupDecimals(decimals\_)
2. Compile your code into bytecode
3. Deploy your Variable-cap Asset by sending your code in a transaction to the Fantom network
4. Navigate to [the Explorer](https://explorer.fantom.network) to check that your token has been created
5. You can use the `_mint` function to create additional units of the token

{% hint style="info" %}

This contract is designed to be unopinionated, allowing developers to access the internal functions in ERC-20 (such as [\_mint](https://docs.openzeppelin.com/contracts/3.x/api/token/erc20#ERC20-_mint-address-uint256-)) and expose them as external functions in the way they prefer. On the other hand, [ERC-20 Presets](https://docs.openzeppelin.com/contracts/3.x/erc20#Presets) (such as [ERC-20PresetMinterPauser](https://docs.openzeppelin.com/contracts/3.x/api/presets#ERC20PresetMinterPauser)) are designed using opinionated patterns to provide developers with ready to use, deployable contracts.
{% endhint %}

<br>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.fantom.foundation/build-on-opera/tutorials/create-variable-cap-asset.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
